/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the ReportConfiguration type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ReportConfiguration{}

// ReportConfiguration struct for ReportConfiguration
type ReportConfiguration struct {
	Id string `json:"id"`
	OrganizationId *string `json:"organization_id,omitempty"`
	Name string `json:"name"`
	Scope ReportConfigurationScope `json:"scope"`
	Data ReportConfigurationData `json:"data"`
	Active bool `json:"active"`
	CreatedAt string `json:"created_at"`
	UpdatedAt string `json:"updated_at"`
}

// NewReportConfiguration instantiates a new ReportConfiguration object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewReportConfiguration(id string, name string, scope ReportConfigurationScope, data ReportConfigurationData, active bool, createdAt string, updatedAt string) *ReportConfiguration {
	this := ReportConfiguration{}
	this.Id = id
	this.Name = name
	this.Scope = scope
	this.Data = data
	this.Active = active
	this.CreatedAt = createdAt
	this.UpdatedAt = updatedAt
	return &this
}

// NewReportConfigurationWithDefaults instantiates a new ReportConfiguration object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewReportConfigurationWithDefaults() *ReportConfiguration {
	this := ReportConfiguration{}
	return &this
}

// GetId returns the Id field value
func (o *ReportConfiguration) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *ReportConfiguration) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *ReportConfiguration) SetId(v string) {
	o.Id = v
}

// GetOrganizationId returns the OrganizationId field value if set, zero value otherwise.
func (o *ReportConfiguration) GetOrganizationId() string {
	if o == nil || IsNil(o.OrganizationId) {
		var ret string
		return ret
	}
	return *o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportConfiguration) GetOrganizationIdOk() (*string, bool) {
	if o == nil || IsNil(o.OrganizationId) {
		return nil, false
	}
	return o.OrganizationId, true
}

// HasOrganizationId returns a boolean if a field has been set.
func (o *ReportConfiguration) HasOrganizationId() bool {
	if o != nil && !IsNil(o.OrganizationId) {
		return true
	}

	return false
}

// SetOrganizationId gets a reference to the given string and assigns it to the OrganizationId field.
func (o *ReportConfiguration) SetOrganizationId(v string) {
	o.OrganizationId = &v
}

// GetName returns the Name field value
func (o *ReportConfiguration) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *ReportConfiguration) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *ReportConfiguration) SetName(v string) {
	o.Name = v
}

// GetScope returns the Scope field value
func (o *ReportConfiguration) GetScope() ReportConfigurationScope {
	if o == nil {
		var ret ReportConfigurationScope
		return ret
	}

	return o.Scope
}

// GetScopeOk returns a tuple with the Scope field value
// and a boolean to check if the value has been set.
func (o *ReportConfiguration) GetScopeOk() (*ReportConfigurationScope, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Scope, true
}

// SetScope sets field value
func (o *ReportConfiguration) SetScope(v ReportConfigurationScope) {
	o.Scope = v
}

// GetData returns the Data field value
func (o *ReportConfiguration) GetData() ReportConfigurationData {
	if o == nil {
		var ret ReportConfigurationData
		return ret
	}

	return o.Data
}

// GetDataOk returns a tuple with the Data field value
// and a boolean to check if the value has been set.
func (o *ReportConfiguration) GetDataOk() (*ReportConfigurationData, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Data, true
}

// SetData sets field value
func (o *ReportConfiguration) SetData(v ReportConfigurationData) {
	o.Data = v
}

// GetActive returns the Active field value
func (o *ReportConfiguration) GetActive() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.Active
}

// GetActiveOk returns a tuple with the Active field value
// and a boolean to check if the value has been set.
func (o *ReportConfiguration) GetActiveOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Active, true
}

// SetActive sets field value
func (o *ReportConfiguration) SetActive(v bool) {
	o.Active = v
}

// GetCreatedAt returns the CreatedAt field value
func (o *ReportConfiguration) GetCreatedAt() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *ReportConfiguration) GetCreatedAtOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *ReportConfiguration) SetCreatedAt(v string) {
	o.CreatedAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *ReportConfiguration) GetUpdatedAt() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *ReportConfiguration) GetUpdatedAtOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *ReportConfiguration) SetUpdatedAt(v string) {
	o.UpdatedAt = v
}

func (o ReportConfiguration) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ReportConfiguration) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	if !IsNil(o.OrganizationId) {
		toSerialize["organization_id"] = o.OrganizationId
	}
	toSerialize["name"] = o.Name
	toSerialize["scope"] = o.Scope
	toSerialize["data"] = o.Data
	toSerialize["active"] = o.Active
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["updated_at"] = o.UpdatedAt
	return toSerialize, nil
}

type NullableReportConfiguration struct {
	value *ReportConfiguration
	isSet bool
}

func (v NullableReportConfiguration) Get() *ReportConfiguration {
	return v.value
}

func (v *NullableReportConfiguration) Set(val *ReportConfiguration) {
	v.value = val
	v.isSet = true
}

func (v NullableReportConfiguration) IsSet() bool {
	return v.isSet
}

func (v *NullableReportConfiguration) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableReportConfiguration(val *ReportConfiguration) *NullableReportConfiguration {
	return &NullableReportConfiguration{value: val, isSet: true}
}

func (v NullableReportConfiguration) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableReportConfiguration) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


